// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

part of ducene;

class Document {
  List<Field> fields = [];
  Document add(Field field) {
    fields.add(field);
    return this;
  }
  static Analyzer defaultAnalyzer = new KeywordAnalyzer();
  Document append(String name, Object text, {Analyzer analyzer}) {
    List<String> txt = [];
    if (text is String) {
      txt.add(text);
    } else if (text is Iterable) {
      txt = text.toList();
    }
    add(new Field(name, txt, (analyzer == null)? defaultAnalyzer : analyzer));
    return this;
  }
  String get(String name) => fields.where((e) => e.name == name).toList()[0].text[0];
  List<String> getValues(String name) => fields.where((e) => e.name == name).toList()[0].text;
}
class Field {
  final String name;
  final List<String> text;
  final Analyzer analyzer;
  Field(this.name, this.text, this.analyzer);
}