// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

part of ducene;

class FieldStats {
  static Map<String,Set<int>> getStats(Set<int> docSet, String field, IndexReader reader) {
    var ret = {};
    var acc = <double>[];
    for (int docId in docSet) {
      List<String> values = reader.getData(field)[docId];
      for (var v in values) {
        acc.add(double.parse(v));
      }
    }
    acc.sort();
    ret['min'] = acc.first;
    ret['max'] = acc.last;
    var count = acc.length;
    ret['count'] = count;
    var sum = acc.reduce((a, b) => a + b);
    ret['sum'] = sum;
    ret['mean'] = sum / count;
    return ret;
  }
}