// Copyright (c) 2016, Shinichiro Abe. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

part of ducene;

class IndexReader {

  final IndexDirectory _directory;

  IndexReader(this._directory);

  Map<String,ListMultimap<String,int>> _indexes;
  Map<String,ListMultimap<int,String>> _data;

  void read() {
    _indexes = _directory.inputIndex();
    _data = _directory.inputData();
  }

  int docFreq(String field, String text) => _indexes[field][text].length;
  int maxDoc() => _data['id'].length;

  Document document(int docId, Iterable<String> fieldsToLoad) {
    Document ret = new Document();
    for (String field in fieldsToLoad) {
      ret.add(new Field(field, _data[field][docId], null));
    }
    return ret;
  }

  ListMultimap<String,int> getTerms(String field) => _indexes[field];
  ListMultimap<int,String> getData(String field) => _data[field];

}

class DirectoryReader {
  static IndexReader open(IndexDirectory directory) => new IndexReader(directory)..read();
}